#include "dialogs.h"

/*
    Standard Gnome About Box.  Nothing to see here. 
    Move along people.
*/
void about(GtkWidget *widget, struct cmj *codemonkey)
{
	GtkWidget *about;

	const gchar *authors[] =
	{
		"V. Alex Brennen <vab@metanet.org>",
		NULL
	};

	about = gnome_about_new(_("CodeMonkey: Java"), VERSION,
				"(c)1998 V. Alex Brennen",
				authors,
				_("CryptNET GTD: CodeMonkey: Java IDE"),
				NULL);

	gtk_window_set_position(GTK_WINDOW(about), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(about), TRUE);
	gtk_widget_show(about);
}

/*
    NYI
*/
void dedication(GtkWidget *widget, struct cmj *codemonkey)
{
	nyi(widget,codemonkey);
}

/*
   Ah yes... The NYI Dialog... Where would I be without it.
*/
void nyi(GtkWidget *widget, struct cmj *codemonkey)
{
	GtkWidget	*nyi;

	nyi = gnome_message_box_new("Not Yet Implemented.", 
		GNOME_MESSAGE_BOX_INFO,
		GNOME_STOCK_BUTTON_OK,
		NULL);
	
	gtk_window_set_modal(GTK_WINDOW(nyi), TRUE);
	gtk_widget_show(nyi);

}

/*
   This function is called by the close call back in the files.c
   when the cb see a 1 in the unsaved variable in the cmj_doc
   struct.  This function builds a dialog which asks the user
   if they would like to save, discard, or cancel.
*/
gint save_unsaved(struct cmj *codemonkey)
{
	GtkWidget *dlog;
	gint return_value;

	dlog = gnome_message_box_new("Do you wish to save this file?",
		GNOME_MESSAGE_BOX_QUESTION,
		GNOME_STOCK_BUTTON_YES,
		GNOME_STOCK_BUTTON_NO,
		GNOME_STOCK_BUTTON_CANCEL,
		NULL);

	return_value = gnome_dialog_run_and_close(GNOME_DIALOG(dlog));
	
	return return_value;
}
