/*** edit.c ***/

#include "edit.h"

void edit_undo(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}
	gtk_extext_undo(GTK_EXTEXT(codemonkey->current->text_box));
}

void edit_redo(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}
	gtk_extext_redo(GTK_EXTEXT(codemonkey->current->text_box));
}

void edit_undo_all(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}
	undo_all(codemonkey->current);
	nyi(widget,codemonkey);
}

void edit_redo_all(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}
	redo_all(codemonkey->current);
	nyi(widget,codemonkey);
}

void edit_cut(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current != NULL)
	{
		gtk_editable_cut_clipboard(GTK_EDITABLE(codemonkey->current->text_box));
	}
}

void edit_copy(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current != NULL)
	{
		gtk_editable_copy_clipboard(GTK_EDITABLE(codemonkey->current->text_box));
	}
}

void edit_paste(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current != NULL)
	{
		gtk_editable_paste_clipboard(GTK_EDITABLE(codemonkey->current->text_box));
	}
}

void edit_clear(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current != NULL)
	{
		gtk_editable_delete_selection(GTK_EDITABLE(codemonkey->current->text_box));
	}
}

void edit_select_all(GtkWidget *widget, struct cmj *codemonkey)
{
	if(codemonkey->current == NULL)
	{
		return;
	}
	nyi(widget,codemonkey);
}
