/* this functions is NOT for USER API */

/*****************************************************************************/
/*                                    Utils                                      */
/*****************************************************************************/

gboolean is_value_ok(gint value,gint start,gint end);
gint get_next_return(gchar *text,gint len);
gint get_tab_count(gchar *txt,gint len);
gint get_return_count(gchar *txt,gint len);
gint get_real_text_height(GdkFont *font);

/*****************************************************************************/
/*                               InsertDelete characters API                                 */
/* Some of this is stolen from Scintilla GTK Widget source										*/
/*****************************************************************************/

static gint text_insert(GtkExText *text,gint pos,char *txt,gint len,gboolean changed_signal);
static gint text_remove(GtkExText *text,gint startpos,gint len);
static void make_room_for(GtkExText *text,gint length);
void gap_to(GtkExText *text,gint length);
static gint text_set_pos(GtkExText *class,gint pos);
guchar * text_get_text_with_expanded_tabs(GtkExText *text, gint start, gint end, gint *tabindex);
guchar * text_get_text(GtkExText *text,gint start,gint end);
gint text_select(GtkExText *text,gint start,gint end);
gint move_cursor(GtkExText *text,gint moveto, gboolean select);


/*****************************************************************************/
/*                              Undo buffertcode                                */
/*****************************************************************************/

void extext_undo_foreach(gpointer data,gpointer user_data);
void extext_undo_insert(GtkExText *text,gint type, gint start, gint end);

/*****************************************************************************/
/*                           Insert Delete Line code                             */
/*****************************************************************************/


static gint line_get_num(GtkExText *text,LineCache *cur,gboolean forward);
/* line_get_ptr also updates line if not correct value */
static LineCache *line_get_ptr(GtkExText *text,gint *line); 
static gint line_get_length(GtkExText *text,LineCache *cur);
static LineCache* line_insert(GtkExText *textext,LineCache *cur,gint count,gint *lineindex);
static LineCache* line_change(GtkExText *textext,LineCache *,gint len);
static LineCache* line_remove(GtkExText *textext,LineCache *cur,gint *lineindex);
static LineCache* line_set_by_ptr(GtkExText *class,LineCache *line,gint index,gboolean forward);
static LineCache* line_set(GtkExText *text,gint line);
static gint line_get_end_pos(GtkExText *textext,LineCache *cur);
static gint line_get_start_pos(GtkExText *class,LineCache *cur);
static gint line_get_end_pos_by_offset(GtkExText *textext,LineCache *cur,gint offset);
static gint line_set_cursor_pos(GtkExText *text,gint pos);

/*  line_get_by_char_pos returns LineCache * and lineindex */
static LineCache* line_get_by_char_pos(GtkExText *text,gint pos,gint *linindex);


/*static void recalculate_line_count(GtkExText *text);
*/
/*****************************************************************************/
/*                        Insert/Delete Style Cache API                          */
/*****************************************************************************/

void property_class_destroy(GtkExText *text);

/* use this to call first property list at selpos */
/* use in scroll_line_start */
GtkExTextProperty * property_get_nearest_at_pos(GtkExText *text,gint pos,gboolean forward,GtkExTextProperty *old);



/*****************************************************************************/
/*                                 WIDGET API                                   */
/*****************************************************************************/

static void gtk_extext_set_arg (GtkObject        *object,
		  GtkArg           *arg,
		  guint             arg_id);
static void gtk_extext_get_arg (GtkObject        *object,
		  GtkArg           *arg,
		  guint             arg_id);


void  expose_parse_line_text(GtkExText *text,GdkDrawable *draw,
									gint lines,LineCache *lptr,gint line_startpos,
										GtkExTextProperty *prop,gint x, gint y);

static void  gtk_extext_adjustment_changed     (GtkAdjustment  *adjustment,
				      GtkExText        *text);
static void  gtk_extext_adjustment_value_changed     (GtkAdjustment  *adjustment,
				      GtkExText        *text);
static void  gtk_extext_disconnect     (GtkAdjustment  *adjustment,
				      GtkExText        *text);

static void gtk_extext_class_init(GtkExTextClass *text);
static void gtk_extext_init(GtkExText *text);
static void gtk_extext_destroy(GtkObject *text);

static void  gtk_extext_finalize       (GtkObject      *object);
static void  gtk_extext_realize        (GtkWidget      *widget);
static void  gtk_extext_unrealize      (GtkWidget      *widget);

/* Event handlers */

static void recompute_geometry (GtkExText* text);
static void gtk_extext_size_allocate (GtkWidget     *widget,
			GtkAllocation *allocation);

static void  gtk_extext_size_request   (GtkWidget      *widget,
				      GtkRequisition *requisition);

static void  gtk_extext_draw              (GtkWidget         *widget,
					 GdkRectangle      *area);
static gint  gtk_extext_expose            (GtkWidget         *widget,
					 GdkEventExpose    *event);
static gint  gtk_extext_button_press      (GtkWidget         *widget,
					 GdkEventButton    *event);
static gint  gtk_extext_button_release    (GtkWidget         *widget,
					 GdkEventButton    *event);
static gint  gtk_extext_motion_notify     (GtkWidget         *widget,
					 GdkEventMotion    *event);
static gint  gtk_extext_key_press         (GtkWidget         *widget,
					 GdkEventKey       *event);
static gint  gtk_extext_focus_in          (GtkWidget         *widget,
					 GdkEventFocus     *event);
static gint  gtk_extext_focus_out         (GtkWidget         *widget,
				         GdkEventFocus     *event);
static gint gtk_extext_motion_notify(GtkWidget *widget,GdkEventMotion *event);

static void gtk_extext_draw_focus(GtkWidget *widget);


/*****************************************************************************/
/*                                 New signals                                   */
/*****************************************************************************/



/*****************************************************************************/
/*                       Overrided GtkEditable functions                         */
/*****************************************************************************/

static void gtk_extext_update_text(GtkEditable *editable,gint startpos,gint endpos);
static void gtk_extext_insert_text       (GtkEditable       *editable,
					const gchar       *new_text,
					gint               new_text_length,
					gint               *position);

static void gtk_extext_delete_text       (GtkEditable       *editable,
					gint              startpos,
					gint               endpos);
static void gtk_extext_select_region(GtkEditable *editable,gint start,gint end);
static gchar *gtk_extext_get_chars(GtkEditable *editable,gint start,gint end);
static void gtk_extext_set_editable(GtkEditable *,gboolean setit);

static void gtk_extext_delete_to_line_end(GtkExText *text);
static void gtk_extext_delete_backward_word(GtkExText *text);
static void gtk_extext_delete_line(GtkExText *text);

static GtkWidgetClass *parent_class = NULL;

typedef struct _InternalPaintCache
{
	GtkExTextStyle *style;
	gint len;
} InternalPaintCache;

void view_to_scroll(GtkExText *text);
void scroll_to_view(GtkExText *text,gint line);
static LineCache *goto_line(GtkExText *text,gint lineto,gboolean sel,gboolean killselect);
static void find_cursor(GtkExText *text,gdouble x,gdouble y,gboolean select);
static void update_select(GtkExText *text,gint oldpos,gboolean select,gboolean killselect);
