/***  toolbar.h ***/

#include <gtk/gtk.h>
#include <gnome.h>
#include <stdio.h>

#include "datastructures.h"

#include "../pixmaps/compile.xpm"

extern void file_new(GtkWidget *widget, struct cmj *codemonkey);
extern void file_open(GtkWidget *widget, struct cmj *codemonkey);
extern void file_save(GtkWidget *widget, struct cmj *codemonkey);
extern void file_close(GtkWidget *widget, struct cmj *codemonkey);
extern void file_quit(GtkWidget *widget, struct cmj *codemonkey);

extern void edit_cut(GtkWidget  *widget, struct cmj *codemonkey);
extern void edit_copy(GtkWidget *widget, struct cmj *codemonkey);
extern void edit_paste(GtkWidget *widget, struct cmj *codemonkey);

extern void search_find(GtkWidget *widget, struct cmj *codemonkey);

extern void	jdk_compile(GtkWidget *widget, struct cmj *codemonkey);
extern void	jdk_execute(GtkWidget *widget, struct cmj *codemonkey);

void set_up_toolbar(struct cmj *codemonkey);


static GnomeUIInfo tool_bar[] =
{
	GNOMEUIINFO_ITEM_STOCK(N_("New"),N_("New File"),file_new,GNOME_STOCK_PIXMAP_NEW),
	GNOMEUIINFO_ITEM_STOCK(N_("Open"),N_("Open File"),file_open,GNOME_STOCK_PIXMAP_OPEN),
	GNOMEUIINFO_ITEM_STOCK(N_("Close"),N_("Close File"),file_close,GNOME_STOCK_PIXMAP_CLOSE),
	GNOMEUIINFO_ITEM_STOCK(N_("Save"),N_("Save File"),file_save,GNOME_STOCK_PIXMAP_SAVE),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK(N_("Cut"),N_("Cut Text To Clipboard"),edit_cut,GNOME_STOCK_PIXMAP_CUT),
	GNOMEUIINFO_ITEM_STOCK(N_("Copy"),N_("Copy Text To Clipboard"),edit_copy,GNOME_STOCK_PIXMAP_COPY),
	GNOMEUIINFO_ITEM_STOCK(N_("Paste"),N_("Paste Text To Clipbaord"),edit_paste,GNOME_STOCK_PIXMAP_PASTE),
	GNOMEUIINFO_ITEM_STOCK(N_("Search"),N_("Search"),search_find,GNOME_STOCK_PIXMAP_SEARCH),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM(N_("Compile"),N_("Compile"),jdk_compile,compile_xpm),
	GNOMEUIINFO_ITEM_STOCK(N_("Execute"),N_("Execute"),jdk_execute,GNOME_STOCK_PIXMAP_EXEC),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK(N_("Exit"),N_("Exit CodeMonkey: Java"),file_quit,GNOME_STOCK_PIXMAP_QUIT),
	GNOMEUIINFO_END
};
